/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim: set ts=8 sts=2 et sw=2 tw=80: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_Components_h
#define mozilla_Components_h

#include "nsCOMPtr.h"

struct nsID;

#define NS_IMPL_COMPONENT_FACTORY(iface) \
  template <>                            \
  already_AddRefed<nsISupports> mozCreateComponent<iface>()

template <typename T>
already_AddRefed<nsISupports> mozCreateComponent();

namespace mozilla {
namespace xpcom {

enum class ModuleID : uint16_t {
  Anonymous042,
  Anonymous023,
  Anonymous483,
  Anonymous515,
  Anonymous554,
  Anonymous054,
  Anonymous116,
  Anonymous576,
  Anonymous249,
  Anonymous456,
  Anonymous046,
  Anonymous496,
  Anonymous275,
  Anonymous524,
  Anonymous606,
  Anonymous010,
  Anonymous218,
  Anonymous057,
  Anonymous085,
  Anonymous504,
  Anonymous688,
  Anonymous020,
  Anonymous625,
  Anonymous113,
  Anonymous489,
  Anonymous265,
  Anonymous204,
  CacheStorage,
  Anonymous072,
  Anonymous212,
  Anonymous344,
  Anonymous520,
  Anonymous526,
  Anonymous588,
  Anonymous080,
  Anonymous089,
  Anonymous400,
  Anonymous343,
  Anonymous484,
  Anonymous104,
  HttpActivityDistributor,
  Anonymous134,
  Anonymous620,
  Anonymous021,
  Anonymous615,
  Anonymous437,
  Anonymous101,
  Anonymous073,
  Anonymous142,
  Anonymous264,
  Anonymous586,
  Anonymous286,
  Anonymous435,
  Anonymous081,
  ApplicationReputation,
  Anonymous460,
  Anonymous498,
  URLQueryStringStripper,
  LoginReputation,
  Anonymous277,
  Anonymous671,
  Anonymous369,
  Anonymous525,
  Anonymous156,
  Anonymous016,
  Anonymous214,
  Anonymous039,
  Anonymous527,
  Anonymous699,
  Anonymous600,
  Anonymous648,
  Anonymous697,
  Anonymous512,
  Anonymous290,
  Anonymous165,
  Anonymous207,
  Anonymous313,
  Anonymous311,
  Anonymous563,
  IdentityCredentialStorageService,
  Anonymous405,
  Anonymous243,
  Anonymous120,
  Anonymous644,
  Anonymous370,
  ExtensionPolicy,
  Anonymous109,
  Anonymous521,
  Anonymous230,
  Anonymous376,
  Anonymous677,
  Anonymous008,
  Anonymous387,
  Anonymous182,
  Anonymous649,
  Anonymous169,
  Anonymous177,
  Anonymous551,
  Anonymous219,
  Anonymous618,
  Anonymous655,
  Anonymous065,
  Anonymous670,
  Anonymous589,
  Anonymous308,
  Anonymous173,
  History,
  Anonymous578,
  Anonymous183,
  Anonymous194,
  Anonymous687,
  Anonymous603,
  Anonymous132,
  Anonymous318,
  Anonymous248,
  Anonymous462,
  Anonymous610,
  Anonymous247,
  Anonymous236,
  Anonymous401,
  Anonymous696,
  Anonymous487,
  DNS,
  Anonymous110,
  Anonymous380,
  Anonymous235,
  Anonymous312,
  Anonymous340,
  IO,
  Anonymous244,
  Anonymous658,
  Anonymous260,
  Anonymous626,
  Anonymous420,
  Anonymous485,
  Anonymous449,
  Anonymous025,
  Anonymous271,
  Anonymous500,
  Anonymous506,
  Anonymous582,
  Anonymous652,
  Anonymous119,
  Anonymous017,
  Anonymous255,
  Anonymous160,
  Anonymous296,
  Anonymous048,
  Anonymous043,
  Anonymous623,
  Anonymous295,
  Anonymous216,
  Anonymous263,
  Imap,
  Anonymous391,
  Anonymous486,
  Anonymous567,
  Anonymous266,
  Anonymous592,
  Anonymous511,
  Anonymous608,
  Anonymous624,
  Anonymous152,
  Anonymous562,
  ThirdPartyUtil,
  Anonymous397,
  Anonymous125,
  Anonymous361,
  Anonymous341,
  Anonymous213,
  Anonymous455,
  Anonymous410,
  Anonymous211,
  Anonymous522,
  Anonymous191,
  Anonymous701,
  Anonymous226,
  Anonymous317,
  Anonymous389,
  Anonymous335,
  Anonymous523,
  Anonymous656,
  Anonymous654,
  MailNotification,
  Anonymous232,
  Anonymous510,
  Anonymous668,
  Anonymous628,
  Anonymous086,
  Anonymous693,
  Anonymous055,
  Anonymous321,
  Anonymous005,
  Anonymous611,
  Anonymous448,
  Anonymous060,
  FindService,
  CookieBannerService,
  Anonymous647,
  Anonymous438,
  Anonymous192,
  Anonymous571,
  Anonymous225,
  Anonymous470,
  Anonymous090,
  Anonymous170,
  Anonymous399,
  Anonymous440,
  Anonymous351,
  Anonymous269,
  Anonymous439,
  Anonymous342,
  Anonymous558,
  Anonymous178,
  Anonymous402,
  Anonymous199,
  Anonymous058,
  Anonymous599,
  Anonymous161,
  Anonymous250,
  StringBundle,
  Anonymous189,
  Anonymous333,
  Anonymous508,
  Anonymous632,
  XULRuntime,
  Anonymous067,
  Anonymous114,
  Anonymous251,
  Anonymous675,
  Anonymous176,
  Anonymous428,
  Anonymous224,
  Anonymous309,
  Anonymous388,
  Anonymous617,
  Anonymous151,
  Anonymous479,
  Anonymous068,
  Anonymous546,
  Anonymous559,
  Anonymous494,
  Anonymous663,
  PermissionManager,
  Anonymous543,
  Anonymous542,
  Anonymous179,
  StreamTransport,
  Anonymous077,
  AlertNotification,
  Anonymous310,
  Anonymous133,
  Anonymous613,
  Anonymous393,
  Anonymous092,
  Anonymous362,
  Anonymous604,
  Anonymous123,
  Anonymous258,
  Anonymous122,
  Anonymous704,
  Anonymous416,
  Anonymous539,
  Anonymous392,
  Anonymous366,
  Anonymous548,
  Anonymous062,
  UrlClassifierPrefixSet,
  Anonymous488,
  Anonymous099,
  Anonymous180,
  Anonymous233,
  Anonymous680,
  Anonymous591,
  Anonymous480,
  Anonymous302,
  Anonymous012,
  Anonymous622,
  Anonymous553,
  Anonymous162,
  Anonymous619,
  Anonymous382,
  Anonymous294,
  Anonymous238,
  Anonymous465,
  Anonymous111,
  Anonymous322,
  Anonymous672,
  Anonymous184,
  Anonymous497,
  DBusHandlerApp,
  Anonymous146,
  Anonymous091,
  Anonymous408,
  Anonymous130,
  Anonymous596,
  Anonymous629,
  Anonymous572,
  Anonymous467,
  Anonymous227,
  Anonymous372,
  Anonymous415,
  Anonymous050,
  Anonymous300,
  Anonymous049,
  Anonymous491,
  Anonymous064,
  Anonymous445,
  Anonymous354,
  Anonymous059,
  Anonymous379,
  Anonymous206,
  Anonymous583,
  URIFixup,
  Anonymous195,
  Anonymous339,
  Anonymous579,
  Anonymous505,
  Anonymous573,
  AbManager,
  Anonymous528,
  Anonymous032,
  Anonymous336,
  Anonymous635,
  Anonymous185,
  Anonymous660,
  Anonymous256,
  Anonymous006,
  Anonymous681,
  Anonymous425,
  Anonymous186,
  Anonymous646,
  Anonymous569,
  Anonymous630,
  Anonymous040,
  Anonymous240,
  Anonymous353,
  Anonymous217,
  Anonymous363,
  Anonymous507,
  Anonymous287,
  Anonymous466,
  Anonymous037,
  Anonymous172,
  Anonymous364,
  Anonymous469,
  Anonymous679,
  Anonymous452,
  Anonymous518,
  Anonymous544,
  Anonymous377,
  Anonymous284,
  Anonymous614,
  Anonymous070,
  Anonymous597,
  Anonymous163,
  Anonymous536,
  Anonymous664,
  Anonymous673,
  Anonymous299,
  Anonymous694,
  Anonymous131,
  Anonymous564,
  ExternalProtocolHandler,
  Anonymous001,
  Anonymous174,
  Anonymous513,
  Anonymous304,
  Anonymous385,
  Anonymous602,
  Anonymous082,
  Anonymous538,
  Anonymous406,
  Anonymous303,
  Anonymous482,
  Anonymous047,
  Anonymous315,
  Anonymous595,
  Anonymous492,
  Anonymous568,
  UrlClassifierUtils,
  Anonymous338,
  Anonymous708,
  Anonymous529,
  Anonymous570,
  Anonymous171,
  GfxInfo,
  Anonymous424,
  Anonymous352,
  Anonymous301,
  Anonymous422,
  Anonymous102,
  Anonymous215,
  Anonymous514,
  Anonymous329,
  Anonymous289,
  Anonymous375,
  Anonymous473,
  Anonymous474,
  Anonymous279,
  Anonymous631,
  Anonymous257,
  Anonymous280,
  Anonymous019,
  Anonymous451,
  Anonymous105,
  Anonymous187,
  Anonymous566,
  DBView,
  Anonymous147,
  Anonymous594,
  Anonymous442,
  Anonymous368,
  Anonymous444,
  Anonymous535,
  AppStartup,
  Anonymous193,
  Anonymous074,
  Anonymous145,
  Anonymous433,
  Anonymous150,
  Anonymous306,
  Anonymous325,
  Anonymous381,
  Anonymous201,
  Anonymous276,
  Anonymous590,
  Anonymous390,
  Anonymous196,
  Anonymous305,
  Anonymous148,
  Anonymous633,
  Anonymous069,
  MailSession,
  Anonymous683,
  Anonymous580,
  Anonymous175,
  Anonymous706,
  Anonymous262,
  Anonymous695,
  Anonymous477,
  Anonymous203,
  Anonymous373,
  URILoader,
  Anonymous014,
  Anonymous403,
  Filter,
  Anonymous285,
  Anonymous029,
  Anonymous674,
  Anonymous398,
  Anonymous639,
  Anonymous033,
  Anonymous314,
  Anonymous661,
  Anonymous575,
  Anonymous346,
  Anonymous292,
  Anonymous121,
  Anonymous495,
  Anonymous367,
  Anonymous087,
  Anonymous094,
  Anonymous155,
  Tag,
  Anonymous124,
  Anonymous274,
  Anonymous320,
  Anonymous096,
  Anonymous259,
  Anonymous550,
  Anonymous686,
  Directory,
  Anonymous471,
  Anonymous540,
  Anonymous396,
  Anonymous499,
  Anonymous607,
  Anonymous653,
  Anonymous252,
  Anonymous636,
  Anonymous464,
  Anonymous220,
  Anonymous298,
  Anonymous041,
  Preferences,
  Anonymous417,
  Anonymous549,
  Anonymous657,
  Anonymous282,
  Anonymous140,
  Anonymous378,
  Anonymous365,
  Anonymous129,
  Anonymous153,
  Anonymous458,
  Anonymous605,
  Anonymous254,
  Anonymous609,
  Anonymous530,
  Anonymous581,
  Anonymous168,
  ServiceWorkerManager,
  Anonymous634,
  Anonymous045,
  Anonymous166,
  Anonymous643,
  Smtp,
  Anonymous443,
  Anonymous509,
  Anonymous272,
  Anonymous650,
  Anonymous547,
  Anonymous585,
  Anonymous328,
  Anonymous242,
  Anonymous167,
  Anonymous587,
  Anonymous281,
  Anonymous565,
  Anonymous418,
  Anonymous278,
  Anonymous355,
  Anonymous117,
  Anonymous642,
  Anonymous118,
  Anonymous627,
  Anonymous052,
  Anonymous239,
  AddonContentPolicy,
  Anonymous078,
  Anonymous407,
  Anonymous103,
  Anonymous404,
  Anonymous356,
  Anonymous360,
  Anonymous357,
  Anonymous202,
  Anonymous205,
  Anonymous349,
  Anonymous098,
  Anonymous095,
  Anonymous430,
  Anonymous330,
  Anonymous447,
  Anonymous490,
  Anonymous412,
  Anonymous053,
  Anonymous088,
  UUIDGenerator,
  Anonymous702,
  Anonymous454,
  Anonymous234,
  Anonymous383,
  Anonymous574,
  Anonymous669,
  Anonymous421,
  Anonymous051,
  Anonymous561,
  Anonymous112,
  Anonymous141,
  Anonymous419,
  Anonymous501,
  Anonymous291,
  Anonymous018,
  Anonymous241,
  Prefetch,
  Anonymous100,
  Anonymous345,
  Anonymous229,
  Anonymous359,
  Anonymous190,
  Anonymous297,
  Anonymous083,
  Anonymous031,
  Anonymous541,
  Anonymous013,
  UrlClassifierDB,
  Anonymous071,
  Anonymous288,
  Anonymous128,
  Anonymous598,
  Anonymous024,
  Anonymous690,
  Anonymous015,
  UrlClassifierStreamUpdater,
  Anonymous431,
  Anonymous331,
  Anonymous637,
  Anonymous030,
  SocketTransport,
  Anonymous332,
  Anonymous157,
  Anonymous426,
  TypeAheadFind,
  Anonymous384,
  Anonymous034,
  Anonymous676,
  Anonymous394,
  Anonymous703,
  Anonymous022,
  Anonymous011,
  ChromeRegistry,
  Anonymous481,
  Anonymous612,
  Anonymous326,
  Anonymous436,
  Anonymous181,
  Anonymous198,
  Anonymous557,
  Observer,
  Folder,
  Anonymous007,
  Anonymous316,
  Anonymous685,
  Anonymous429,
  Anonymous537,
  Anonymous689,
  Anonymous056,
  Anonymous135,
  Anonymous337,
  Anonymous519,
  Anonymous532,
  Anonymous004,
  Anonymous446,
  Anonymous188,
  Anonymous139,
  Anonymous475,
  Anonymous432,
  Import,
  Anonymous684,
  Anonymous601,
  Anonymous468,
  Anonymous577,
  Anonymous427,
  Anonymous137,
  Anonymous638,
  Anonymous531,
  Anonymous009,
  Anonymous516,
  Anonymous534,
  Anonymous395,
  Anonymous545,
  Anonymous273,
  Anonymous434,
  Anonymous645,
  Anonymous270,
  Anonymous493,
  Anonymous223,
  Anonymous063,
  Anonymous593,
  Anonymous246,
  Anonymous409,
  FolderNotification,
  Anonymous665,
  Anonymous324,
  Anonymous036,
  Anonymous158,
  Anonymous093,
  Anonymous414,
  Anonymous659,
  Anonymous616,
  MimeConverter,
  Anonymous371,
  Anonymous678,
  Anonymous267,
  Anonymous461,
  Anonymous127,
  Anonymous667,
  Anonymous692,
  Anonymous472,
  Anonymous003,
  Anonymous560,
  Anonymous261,
  Anonymous035,
  Anonymous028,
  Anonymous463,
  Anonymous453,
  Anonymous348,
  Anonymous411,
  IdentityCredentialPromptService,
  Anonymous374,
  Anonymous293,
  Anonymous209,
  Anonymous126,
  Anonymous698,
  Anonymous413,
  Anonymous237,
  Copy,
  Anonymous222,
  Anonymous641,
  Anonymous707,
  Anonymous076,
  Anonymous651,
  Anonymous502,
  Anonymous108,
  Anonymous283,
  Anonymous555,
  Anonymous666,
  AsyncShutdown,
  Anonymous584,
  Anonymous200,
  Anonymous221,
  Anonymous084,
  Anonymous138,
  Anonymous334,
  Anonymous327,
  Anonymous253,
  Anonymous640,
  Anonymous347,
  Anonymous066,
  Anonymous556,
  DB,
  Anonymous208,
  Anonymous533,
  Anonymous044,
  Anonymous107,
  Anonymous079,
  Anonymous621,
  Anonymous197,
  Anonymous106,
  Anonymous000,
  Anonymous705,
  Anonymous319,
  Anonymous552,
  Anonymous450,
  Anonymous159,
  Anonymous476,
  Anonymous097,
  Anonymous026,
  DownloadPlatform,
  Compose,
  Anonymous143,
  Anonymous144,
  AccountManager,
  Anonymous517,
  Anonymous350,
  Anonymous307,
  Anonymous210,
  Anonymous682,
  Anonymous154,
  Anonymous027,
  Anonymous323,
  Anonymous268,
  Anonymous075,
  Anonymous478,
  Anonymous386,
  Anonymous061,
  Anonymous115,
  Anonymous459,
  Anonymous503,
  Anonymous231,
  HeaderParser,
  Anonymous457,
  Anonymous441,
  Anonymous149,
  Anonymous164,
  Anonymous136,
  Anonymous002,
  Anonymous245,
  DocLoader,
  Anonymous228,
  Anonymous691,
  Anonymous423,
  Anonymous038,
  Anonymous662,
  Anonymous358,
  Anonymous700,
  Alerts,

};

// May be added as a friend function to allow constructing services via
// private constructors and init methods.
nsresult CreateInstanceImpl(ModuleID aID, const nsIID& aIID, void** aResult);

class MOZ_STACK_CLASS StaticModuleHelper : public nsCOMPtr_helper {
 public:
  StaticModuleHelper(ModuleID aId, nsresult* aErrorPtr)
      : mId(aId), mErrorPtr(aErrorPtr) {}

 protected:
  nsresult SetResult(nsresult aRv) const {
    if (mErrorPtr) {
      *mErrorPtr = aRv;
    }
    return aRv;
  }

  ModuleID mId;
  nsresult* mErrorPtr;
};

class MOZ_STACK_CLASS GetServiceHelper final : public StaticModuleHelper {
 public:
  using StaticModuleHelper::StaticModuleHelper;

  nsresult NS_FASTCALL operator()(const nsIID& aIID,
                                  void** aResult) const override;
};

class MOZ_STACK_CLASS CreateInstanceHelper final : public StaticModuleHelper {
 public:
  using StaticModuleHelper::StaticModuleHelper;

  nsresult NS_FASTCALL operator()(const nsIID& aIID,
                                  void** aResult) const override;
};

class Components final {
 public:
  static const nsID& GetCID(ModuleID aID);
};

}  // namespace xpcom

namespace components {

namespace AbManager {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AbManager);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AbManager, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AbManager, aRv};
}
}  // namespace AbManager

namespace AccountManager {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AccountManager);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AccountManager, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AccountManager, aRv};
}
}  // namespace AccountManager

namespace AddonContentPolicy {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AddonContentPolicy);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AddonContentPolicy, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AddonContentPolicy, aRv};
}
}  // namespace AddonContentPolicy

namespace AlertNotification {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AlertNotification);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AlertNotification, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AlertNotification, aRv};
}
}  // namespace AlertNotification

namespace Alerts {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Alerts);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Alerts, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Alerts, aRv};
}
}  // namespace Alerts

namespace AppStartup {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AppStartup);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AppStartup, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AppStartup, aRv};
}
}  // namespace AppStartup

namespace ApplicationReputation {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ApplicationReputation);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ApplicationReputation, aRv};
}
}  // namespace ApplicationReputation

namespace AsyncShutdown {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::AsyncShutdown);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AsyncShutdown, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::AsyncShutdown, aRv};
}
}  // namespace AsyncShutdown

namespace CacheStorage {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::CacheStorage);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::CacheStorage, aRv};
}
}  // namespace CacheStorage

namespace ChromeRegistry {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ChromeRegistry);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ChromeRegistry, aRv};
}
}  // namespace ChromeRegistry

namespace Compose {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Compose);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Compose, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Compose, aRv};
}
}  // namespace Compose

namespace CookieBannerService {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::CookieBannerService);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::CookieBannerService, aRv};
}
}  // namespace CookieBannerService

namespace Copy {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Copy);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Copy, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Copy, aRv};
}
}  // namespace Copy

namespace DB {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DB);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DB, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DB, aRv};
}
}  // namespace DB

namespace DBView {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DBView);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DBView, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DBView, aRv};
}
}  // namespace DBView

namespace DBusHandlerApp {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DBusHandlerApp);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DBusHandlerApp, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DBusHandlerApp, aRv};
}
}  // namespace DBusHandlerApp

namespace DNS {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DNS);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DNS, aRv};
}
}  // namespace DNS

namespace Directory {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Directory);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Directory, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Directory, aRv};
}
}  // namespace Directory

namespace DocLoader {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DocLoader);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DocLoader, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DocLoader, aRv};
}
}  // namespace DocLoader

namespace DownloadPlatform {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::DownloadPlatform);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DownloadPlatform, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::DownloadPlatform, aRv};
}
}  // namespace DownloadPlatform

namespace ExtensionPolicy {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ExtensionPolicy);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ExtensionPolicy, aRv};
}
}  // namespace ExtensionPolicy

namespace ExternalProtocolHandler {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ExternalProtocolHandler);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ExternalProtocolHandler, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ExternalProtocolHandler, aRv};
}
}  // namespace ExternalProtocolHandler

namespace Filter {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Filter);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Filter, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Filter, aRv};
}
}  // namespace Filter

namespace FindService {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::FindService);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::FindService, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::FindService, aRv};
}
}  // namespace FindService

namespace Folder {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Folder);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Folder, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Folder, aRv};
}
}  // namespace Folder

namespace FolderNotification {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::FolderNotification);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::FolderNotification, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::FolderNotification, aRv};
}
}  // namespace FolderNotification

namespace GfxInfo {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::GfxInfo);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::GfxInfo, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::GfxInfo, aRv};
}
}  // namespace GfxInfo

namespace HeaderParser {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::HeaderParser);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::HeaderParser, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::HeaderParser, aRv};
}
}  // namespace HeaderParser

namespace History {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::History);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::History, aRv};
}
}  // namespace History

namespace HttpActivityDistributor {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::HttpActivityDistributor);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::HttpActivityDistributor, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::HttpActivityDistributor, aRv};
}
}  // namespace HttpActivityDistributor

namespace IO {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::IO);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::IO, aRv};
}
}  // namespace IO

namespace IdentityCredentialPromptService {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::IdentityCredentialPromptService);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::IdentityCredentialPromptService, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::IdentityCredentialPromptService, aRv};
}
}  // namespace IdentityCredentialPromptService

namespace IdentityCredentialStorageService {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::IdentityCredentialStorageService);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::IdentityCredentialStorageService, aRv};
}
}  // namespace IdentityCredentialStorageService

namespace Imap {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Imap);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Imap, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Imap, aRv};
}
}  // namespace Imap

namespace Import {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Import);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Import, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Import, aRv};
}
}  // namespace Import

namespace LoginReputation {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::LoginReputation);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::LoginReputation, aRv};
}
}  // namespace LoginReputation

namespace MailNotification {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::MailNotification);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::MailNotification, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::MailNotification, aRv};
}
}  // namespace MailNotification

namespace MailSession {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::MailSession);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::MailSession, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::MailSession, aRv};
}
}  // namespace MailSession

namespace MimeConverter {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::MimeConverter);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::MimeConverter, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::MimeConverter, aRv};
}
}  // namespace MimeConverter

namespace Observer {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Observer);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Observer, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Observer, aRv};
}
}  // namespace Observer

namespace PermissionManager {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::PermissionManager);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::PermissionManager, aRv};
}
}  // namespace PermissionManager

namespace Preferences {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Preferences);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Preferences, aRv};
}
}  // namespace Preferences

namespace Prefetch {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Prefetch);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Prefetch, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Prefetch, aRv};
}
}  // namespace Prefetch

namespace ServiceWorkerManager {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ServiceWorkerManager);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ServiceWorkerManager, aRv};
}
}  // namespace ServiceWorkerManager

namespace Smtp {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Smtp);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Smtp, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Smtp, aRv};
}
}  // namespace Smtp

namespace SocketTransport {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::SocketTransport);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::SocketTransport, aRv};
}
}  // namespace SocketTransport

namespace StreamTransport {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::StreamTransport);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StreamTransport, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StreamTransport, aRv};
}
}  // namespace StreamTransport

namespace StringBundle {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::StringBundle);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StringBundle, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::StringBundle, aRv};
}
}  // namespace StringBundle

namespace Tag {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::Tag);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Tag, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::Tag, aRv};
}
}  // namespace Tag

namespace ThirdPartyUtil {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::ThirdPartyUtil);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ThirdPartyUtil, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::ThirdPartyUtil, aRv};
}
}  // namespace ThirdPartyUtil

namespace TypeAheadFind {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::TypeAheadFind);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::TypeAheadFind, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::TypeAheadFind, aRv};
}
}  // namespace TypeAheadFind

namespace URIFixup {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::URIFixup);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URIFixup, aRv};
}
}  // namespace URIFixup

namespace URILoader {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::URILoader);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URILoader, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URILoader, aRv};
}
}  // namespace URILoader

namespace URLQueryStringStripper {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::URLQueryStringStripper);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::URLQueryStringStripper, aRv};
}
}  // namespace URLQueryStringStripper

namespace UUIDGenerator {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UUIDGenerator);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UUIDGenerator, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UUIDGenerator, aRv};
}
}  // namespace UUIDGenerator

namespace UrlClassifierDB {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierDB);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierDB, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierDB, aRv};
}
}  // namespace UrlClassifierDB

namespace UrlClassifierPrefixSet {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierPrefixSet);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierPrefixSet, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierPrefixSet, aRv};
}
}  // namespace UrlClassifierPrefixSet

namespace UrlClassifierStreamUpdater {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierStreamUpdater);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierStreamUpdater, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierStreamUpdater, aRv};
}
}  // namespace UrlClassifierStreamUpdater

namespace UrlClassifierUtils {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::UrlClassifierUtils);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierUtils, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::UrlClassifierUtils, aRv};
}
}  // namespace UrlClassifierUtils

namespace XULRuntime {
static inline const nsID& CID() {
  return ::mozilla::xpcom::Components::GetCID(::mozilla::xpcom::ModuleID::XULRuntime);
}

static inline ::mozilla::xpcom::GetServiceHelper Service(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::XULRuntime, aRv};
}

static inline ::mozilla::xpcom::CreateInstanceHelper Create(nsresult* aRv = nullptr) {
  return {::mozilla::xpcom::ModuleID::XULRuntime, aRv};
}
}  // namespace XULRuntime

}  // namespace components

}  // namespace mozilla

#endif
